<script lang="ts">
import Vue from 'vue';
import AnimatedNumber from './animated-number.vue';
import ParallaxContainer from './parallax-container.vue';
import StatsGridOrbs1 from './assets/stats-grid-orbs-1.vue';
import StatsGridOrbs2 from './assets/stats-grid-orbs-2.vue';
import StatsGridOrbs3 from './assets/stats-grid-orbs-3.vue';
import StatsGridOrbs4 from './assets/stats-grid-orbs-4.vue';

export default Vue.extend({
  name: 'StatsGrid',
  components: {
    AnimatedNumber,
    ParallaxContainer,
    StatsGridOrbs1,
    StatsGridOrbs2,
    StatsGridOrbs3,
    StatsGridOrbs4,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <section class="stats-grid">
    <SlpContainer>
      <SlpRow class="stats-grid__row">
        <SlpColumn
          v-for="(block, index) in data.blocks"
          :key="block.subhead"
          :cols="5"
          class="stats-grid__col"
        >
          <div>
            <div class="stats-grid__graphic">
              <ParallaxContainer :offset="0.05" direction="up">
                <component :is="`stats-grid-orbs-${index + 1}`" />
              </ParallaxContainer>
            </div>

            <div
              ref="textContainer"
              class="stats-grid__text-container"
              :data-aos="data.aos_animation"
              :data-aos-duration="data.aos_duration"
              :data-aos-offset="data.aos_offset"
            >
              <SlpTypography
                v-if="block.title"
                variant="heading5-bold"
                tag="p"
                class="stats-grid__title slp-mb-8"
                >{{ block.title }}</SlpTypography
              >
              <AnimatedNumber
                :number="block.percent"
                :delay="block.delay"
                :threshold="0.5"
                class="stats-grid__number slp-mb-16"
                :speed="(100 / block.percent) * 10"
              />
              <SlpTypography v-if="block.description" variant="body1" tag="p">{{
                block.description
              }}</SlpTypography>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.stats-grid {
  color: $color-primary-300;
  margin-bottom: 0 !important;
  &__col {
    position: relative;
    padding: $spacing-32;
    margin-bottom: $spacing-64;
    &:last-of-type {
      margin-bottom: 0;
    }
    @media (min-width: $breakpoint-md) {
      margin-bottom: $spacing-32;
      padding-bottom: $spacing-160;
    }
  }
  &__number {
    font-family: 'Jet Brains Mono';

    :deep * {
      font-size: $spacing-160;
      line-height: 1;
    }
  }
  &__title {
    color: #67cfb7;
  }
  &__row {
    justify-content: space-around;
  }
  &__text-container {
    max-width: 360px;
    &::before {
      content: '';
      position: absolute;
      width: 207.32px;
      height: 208.02px;
      background: radial-gradient(
        50% 50% at 50% 50%,
        rgba(176, 146, 242, 0.4) 0%,
        rgba(176, 146, 242, 0) 85.67%
      );
    }
  }
  &__graphic {
    position: absolute;
    top: 0%;
    width: 100%;
    height: 100%;
    left: 0;
  }
}
</style>
